<?php
// $Id
// Just a convenient place to stick all of the dedicated admin pages so they don't clutter up the main module.


function customvote_overview() {
  $links = array('%content' => 'admin/settings/content-types');
  $output .= '<h3>' . t('Voting system overview') . '</h3>';
  $output .= '<p>' . t('To set up the default voting options for all nodes and comments, use the form below. Use the <a href="%content">content administration</a> page to override the options for specific node types.', $links) . '</p>';
  $type = 'node_default';
  
  $form['nodes'] = _customvote_build_admin_options($type);
  $form['nodes']['#title'] = t('Node voting options');

  $type = 'comment';
  $form['comments'] = _customvote_build_admin_options($type);
  $form['comments']['#title'] = t('Comment voting options');
  $form['comments']['customvote_comment_display_widget']['#options'] = array(CUSTOMVOTE_PLACEMENT_BEFORE=>t('Display before body'), CUSTOMVOTE_PLACEMENT_AFTER=>t('Display after body'), CUSTOMVOTE_PLACEMENT_NONE=>t('Do not display'));
  $form['comments']['customvote_comment_display_results']['#options'] = array(CUSTOMVOTE_PLACEMENT_BEFORE=>t('Display before body'), CUSTOMVOTE_PLACEMENT_AFTER=>t('Display after body'), CUSTOMVOTE_PLACEMENT_NONE=>t('Do not display'));
  unset($form['comments']['customvote_comments_moderation']);

  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => 'Save options',
  );

  $output .= drupal_get_form('customvote_overview_form', $form);
  return $output;
}

function customvote_overview_form_submit($form_id, $form_values) {
  $type = 'node_default';
  variable_set('customvote_'.$type.'_enabled', $form_values['customvote_'.$type.'_enabled']);
  variable_set('customvote_'.$type.'_roles', $form_values['customvote_'.$type.'_roles']);
  variable_set('customvote_'.$type.'_display_widget', $form_values['customvote_'.$type.'_display_widget']);
  variable_set('customvote_'.$type.'_display_results', $form_values['customvote_'.$type.'_display_results']);
  variable_set('customvote_'.$type.'_caption', $form_values['customvote_'.$type.'_caption']);
  variable_set('customvote_'.$type.'_help', $form_values['customvote_'.$type.'_help']);
  variable_set('customvote_'.$type.'_moderation', $form_values['customvote_'.$type.'_moderation']);
  variable_set('customvote_'.$type.'_allow_author_vote', $form_values['customvote_'.$type.'_allow_author_vote']);
  variable_set('customvote_'.$type.'_allow_change', $form_values['customvote_'.$type.'_allow_change']);
  variable_set('customvote_'.$type.'_voteset', $form_values['customvote_'.$type.'_voteset']);
  variable_set('customvote_'.$type.'_criteria', $form_values['customvote_'.$type.'_criteria']);
  variable_set('customvote_'.$type.'_criteria_names', $form_values['customvote_'.$type.'_criteria_names']);
  variable_set('customvote_'.$type.'_average', $form_values['customvote_'.$type.'_average']);
  
  $type = 'comment';
  variable_set('customvote_'.$type.'_enabled', $form_values['customvote_'.$type.'_enabled']);
  variable_set('customvote_'.$type.'_roles', $form_values['customvote_'.$type.'_roles']);
  variable_set('customvote_'.$type.'_display_widget', $form_values['customvote_'.$type.'_display_widget']);
  variable_set('customvote_'.$type.'_display_results', $form_values['customvote_'.$type.'_display_results']);
  variable_set('customvote_'.$type.'_caption', $form_values['customvote_'.$type.'_caption']);
  variable_set('customvote_'.$type.'_help', $form_values['customvote_'.$type.'_help']);
  variable_set('customvote_'.$type.'_allow_author_vote', $form_values['customvote_'.$type.'_allow_author_vote']);
  variable_set('customvote_'.$type.'_allow_change', $form_values['customvote_'.$type.'_allow_change']);
  variable_set('customvote_'.$type.'_voteset', $form_values['customvote_'.$type.'_voteset']);
  variable_set('customvote_'.$type.'_criteria', $form_values['customvote_'.$type.'_criteria']);
  variable_set('customvote_'.$type.'_criteria_names', $form_values['customvote_'.$type.'_criteria_names']);
  variable_set('customvote_'.$type.'_average', $form_values['customvote_'.$type.'_average']);
}

/*
 * 
 */
 
/* Table contains the following fields:
  sid int(10) unsigned NOT NULL,                        # set id
  name varchar(255) default NULL,                       # name of vote set
  weight tinyint(4) NOT NULL default '0',               # weight. unused at present.
  type tinyint(4) NOT NULL default '0',                 # set type. determines the internal methods used to render/process votes
 */
 
function customvote_set_list() {
  $output .= '<p>' . t('Create and edit voting sets for use with different types of content.') . '</p>';

  $set_types = _customvote_get_set_types();

  // load up and show any vote sets previously defined.
  $result = db_query('SELECT sid, name, type, weight FROM {customvote_vote_sets} ORDER BY weight');
  while ($set = db_fetch_object($result)) {
    $form['old'][$set->sid]['name'] = array(
      '#type' => 'textfield',
      '#default_value' => $set->name,
      '#size' => 32,
      '#maxlength' => 64,
    );
 
	  $form['old'][$set->sid]['type'] = array(
	    '#type' => 'hidden',
	    '#value' => $set->type,
	  );
    
    $form['old'][$set->sid]['weight'] = array(
	    '#type' => 'weight',
	    '#delta' => 15,
      '#default_value' => $set->weight,
    );
  }
  
  // Add a set of fields for new votes.
  $form['new']['name'] = array(
   '#type' => 'textfield',
   '#size' => 32,
   '#maxlength' => 64,
  );

  $form['new']['type'] = array(
    '#type' => 'select',
    '#options' => $set_types,
  );

  $form['new']['weight'] = array(
    '#type' => 'weight',
    '#delta' => 15,
  );

  $form['#tree'] = TRUE; // make sure we preserve all hierarchial values.
  $form[] = array(
    '#type' => 'submit',
    '#value' => t('Save changes'),
  );

  $output .= drupal_get_form('customvote_set_list_form', $form);
  return $output;
}

function customvote_set_list_form_submit($form_id, $form_values) {  
  $sql = "UPDATE {customvote_vote_sets} SET name = '%s', weight = %d WHERE sid = %d";
  foreach (element_children($form_values['old']) as $sid) {
    db_query($sql, $form_values['old'][$sid]['name'], $form_values['old'][$sid]['weight'], $sid);
  }

  if ($form_values['new']['name'] != '' && $form_values['new']['type'] != '') {
    $sql = "INSERT INTO {customvote_vote_sets} (sid, name, type, weight) VALUES (%d, '%s', '%s', %d)";
    db_query($sql, db_next_id('customvote_vote_sets'), $form_values['new']['name'], $form_values['new']['type'], $form_values['new']['weight']); 
  }
  drupal_goto('admin/vote/sets');
}


function theme_customvote_set_list_form($form) {
  $set_types = _customvote_get_set_types();

  $header = array(t('vote set name'), t('vote type'), t('weight'), t('actions'));

  foreach (element_children($form['old']) as $sid) {
    $row = array();
    $row[] = form_render($form['old'][$sid]['name']);
    $row[] = $set_types[$form['old'][$sid]['type']['#value']];
    $row[] = form_render($form['old'][$sid]['weight']);
    $row[] = l(t('edit'), 'admin/vote/sets/edit/' . $sid) . ' | ' . l(t('delete'), 'admin/vote/sets/delete/' . $sid);
    $rows[] = $row;
  }

  if (!$rows) {
    $rows[] = array(array('data' => t('No sets have been defined.'), 'colspan' => '4'));
  }
  else {
    $rows[] = array(array('data' => t('Create a new set below'), 'colspan' => '4'));
  }
      
  $row = array();
  $row[] = form_render($form['new']['name']);
  $row[] = form_render($form['new']['type']);
  $row[] = form_render($form['new']['weight']);
  $row[] = '';
  $rows[] = $row;

  $output = theme('table', $header, $rows);
  $output .= form_render($form);
  return $output;
}

function customvote_set_edit($sid) {
  // return a completely different form based on the incoming set id.

  $sql = 'SELECT * FROM {customvote_vote_sets} WHERE sid = %d';
  $set = db_fetch_object(db_query($sql, $sid));
  
  $set_types = _customvote_get_set_types();
  $set_descs = _customvote_get_set_type_descriptions();
  
  $output = '<h3>' . t('Vote set "') . $set->name . '" (' . $set_types[$set->type] . ' style)' . '</h3>';
  $output .= '<p>' . $set_descs[$set->type] . '</p>';
  
  $function = 'customvote_'.$set->type.'_set_edit';
  if (function_exists($function)) {
    $output = $function($set);
  }

  return $output;
}


/*
 * Deleting a given vote set.
 */

function customvote_set_delete($sid) {
  $form['sid'] = array(
    '#type' => 'hidden',
    '#value' => $sid,
  );

  $output = confirm_form(
    'customvote_set_delete_comfirm',
    $form,
    t('Are you sure you want to delete this vote set? All of its votes will be deleted as well.'),
    $_GET['destination'] ? $_GET['destination'] : 'admin/vote/sets',
    t('This action cannot be undone.'),
    t('Delete Set'),
    t('Cancel') 
  );
  return $output;
}

function customvote_set_delete_comfirm_submit($form_id, $form_values) {
  if ($form_values['confirm']) {
    if (user_access('administer voting system')) {
      $sid = $form_values['sid'];

      db_query('DELETE FROM {customvote_votes} WHERE sid = %d', $sid);
      db_query('DELETE FROM {customvote_vote_sets} WHERE sid = %d', $sid);
      
      drupal_set_message(t('Set deleted.'));
      drupal_goto('admin/vote/sets');
    }
    else {
      drupal_access_denied();
    }
  }
}

function customvote_form_alter($form_id, &$form) {
  if (isset($form['type'])) {
      if ($form['type']['#value'] .'_node_settings' == $form_id) {
      $type = $form['type']['#value'];
      
      $form['workflow']['customvote'] = _customvote_build_admin_options($type);
    }
  }
}



function _customvote_build_admin_options($type) {
  $form = array(
    '#type' => 'fieldset',
    '#title' => t('Voting options'),
  );
  
  $form['customvote_'.$type.'_enabled'] = array(
    '#type' => 'radios',
    '#title' => t('Voting'),
    '#default_value' => variable_get('customvote_'.$type.'_enabled', 0),
    '#options' => array(0=>t('Disabled by default'), 1=>t('Enabled by default')),
    '#description' => t('Turn voting on and off for all content types. Specific content types can be enabled in their configuration screens'),
  );
  
  $form['customvote_'.$type.'_roles'] = array(
    '#type' => 'select',
    '#title' => t('Role restrictions'),
    '#required' => TRUE,
    '#multiple' => TRUE,
    '#default_value' => variable_get('customvote_'.$type.'_roles', array('2')),
    '#options' => _customvote_get_non_anon_roles(),
    '#description' => t('Only allow users to vote if they are in the roles listed above.'),
  );

  $form['customvote_'.$type.'_display_widget'] = array(
    '#type' => 'radios',
    '#title' => t('Position of voting widget'),
    '#default_value' => variable_get('customvote_'.$type.'_display_widget', CUSTOMVOTE_PLACEMENT_AFTER),
    '#options' => array(CUSTOMVOTE_PLACEMENT_BEFORE=>t('Display before body'), CUSTOMVOTE_PLACEMENT_AFTER=>t('Display after body'), CUSTOMVOTE_PLACEMENT_BLOCK=>t('Display in block'), CUSTOMVOTE_PLACEMENT_NONE=>t('Do not display')),
    '#description' => t('Where should the voting widget be displayed? If "Do not display" is selected, the widget will still be created and stored invisibly for use by a theme.'),
  );

  $form['customvote_'.$type.'_display_results'] = array(
    '#type' => 'radios',
    '#title' => t('Position of voting results'),
    '#default_value' => variable_get('customvote_'.$type.'_display_results', CUSTOMVOTE_PLACEMENT_AFTER),
    '#options' => array(CUSTOMVOTE_PLACEMENT_BEFORE=>t('Display before body'), CUSTOMVOTE_PLACEMENT_AFTER=>t('Display after body'), CUSTOMVOTE_PLACEMENT_BLOCK=>t('Display in block'), CUSTOMVOTE_PLACEMENT_NONE=>t('Do not display')),
    '#description' => t('Where should the voting widget be displayed? If "Do not display" is selected, the widget will still be created and stored invisibly for use by a theme.'),
  );

  $form['customvote_'.$type.'_caption'] = array(
    '#type' => 'textfield',
    '#title' => t('Caption'),
    '#default_value' => variable_get('customvote_'.$type.'_caption', 'Rate this content'),
  );
  
  $form['customvote_'.$type.'_help'] = array(
    '#type' => 'textarea',
    '#title' => t('Help text'),
    '#default_value' => variable_get('customvote_'.$type.'_help', ''),
  );
  
  $form['customvote_'.$type.'_moderation'] = array(
    '#type' => 'checkbox',
    '#title' => t('Only display on moderated nodes'),
    '#default_value' => variable_get('customvote_'.$type.'_moderation', 0),
    '#return_value' => 1,
  );

  $form['customvote_'.$type.'_allow_author_vote'] = array(
    '#type' => 'checkbox',
    '#title' => t('Allow users to vote on their own content'),
    '#default_value' => variable_get('customvote_'.$type.'_allow_author_vote', 0),
    '#return_value' => 1,
  );

  $form['customvote_'.$type.'_allow_changing'] = array(
    '#type' => 'checkbox',
    '#title' => t('Allow users to change their votes'),
    '#default_value' => variable_get('customvote_'.$type.'_allow_changing', 0),
    '#return_value' => 1,
  );
  
  $form['customvote_'.$type.'_voteset'] = array(
    '#type' => 'select',
    '#title' => t('Vote set to use'),
    '#default_value' => variable_get('customvote_'.$type.'_voteset', 0),
    '#options' => _customvote_get_vote_set_list(),
  );
  
  $form['customvote_'.$type.'_criteria'] = array(
    '#type' => 'textarea',
    '#title' => t('Voting criteria keys'),
    '#default_value' => variable_get('customvote_'.$type.'_criteria', ''),
    '#description' => t('To enable multi-criteria voting, enter a unique key for each criteria, one per line'),
  );

  $form['customvote_'.$type.'_criteria_names'] = array(
    '#type' => 'textarea',
    '#title' => t('Voting criteria captions'),
    '#default_value' => variable_get('customvote_'.$type.'_criteria_names', ''),
    '#description' => t('Enter a caption for each vote criteria, one per line'),
  );

  $form['customvote_'.$type.'_average'] = array(
    '#type' => 'checkbox',
    '#title' => t('Calculate overall vote automatically'),
    '#description' => t("In multi-criteria votes, automatically calculate the user's overall vote for the content"),
    '#default_value' => variable_get('customvote_'.$type.'_average', 1),
    '#return_value' => 1,
  );
  
  return $form;
}